<?php

/**
* getLookupMainTableSettings - tests whether the lookup link exists between the tables
*
*  returns array with ProjectSettings class for main table if the link exists in project settings.
*  returns NULL otherwise
*/
function getLookupMainTableSettings($lookupTable, $mainTableShortName, $mainField, $desiredPage = "")
{
	global $lookupTableLinks;
	if(!isset($lookupTableLinks[$lookupTable]))
		return null;
	if(!isset($lookupTableLinks[$lookupTable][$mainTableShortName.".".$mainField]))
		return null;
	$arr = &$lookupTableLinks[$lookupTable][$mainTableShortName.".".$mainField];
	$effectivePage = $desiredPage;
	if(!isset($arr[$effectivePage]))
	{
		$effectivePage = PAGE_EDIT;
		if(!isset($arr[$effectivePage]))
		{
			if($desiredPage == "" && 0 < count($arr))
			{
				$effectivePage = $arr[0];
			}
			else
				return null;
		}
	}
	return new ProjectSettings($arr[$effectivePage]["table"], $effectivePage);
}

/** 
* $lookupTableLinks array stores all lookup links between tables in the project
*/
function InitLookupLinks()
{
	global $lookupTableLinks;

	$lookupTableLinks = array();

		if( !isset( $lookupTableLinks["ref_titles"] ) ) {
			$lookupTableLinks["ref_titles"] = array();
		}
		if( !isset( $lookupTableLinks["ref_titles"]["transxn_com_vac_app_general_info.title_id"] )) {
			$lookupTableLinks["ref_titles"]["transxn_com_vac_app_general_info.title_id"] = array();
		}
		$lookupTableLinks["ref_titles"]["transxn_com_vac_app_general_info.title_id"]["edit"] = array("table" => "transxn_com_vac_app_general_info", "field" => "title_id", "page" => "edit");
		if( !isset( $lookupTableLinks["transxn_com_vacancy_adverts"] ) ) {
			$lookupTableLinks["transxn_com_vacancy_adverts"] = array();
		}
		if( !isset( $lookupTableLinks["transxn_com_vacancy_adverts"]["transxn_com_vac_app_general_info.post_applied_for"] )) {
			$lookupTableLinks["transxn_com_vacancy_adverts"]["transxn_com_vac_app_general_info.post_applied_for"] = array();
		}
		$lookupTableLinks["transxn_com_vacancy_adverts"]["transxn_com_vac_app_general_info.post_applied_for"]["edit"] = array("table" => "transxn_com_vac_app_general_info", "field" => "post_applied_for", "page" => "edit");
		if( !isset( $lookupTableLinks["ref_jobapplicant_status"] ) ) {
			$lookupTableLinks["ref_jobapplicant_status"] = array();
		}
		if( !isset( $lookupTableLinks["ref_jobapplicant_status"]["transxn_com_vac_app_general_info.job_aplication_status"] )) {
			$lookupTableLinks["ref_jobapplicant_status"]["transxn_com_vac_app_general_info.job_aplication_status"] = array();
		}
		$lookupTableLinks["ref_jobapplicant_status"]["transxn_com_vac_app_general_info.job_aplication_status"]["edit"] = array("table" => "transxn_com_vac_app_general_info", "field" => "job_aplication_status", "page" => "edit");
}

?>